
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _OK_Flag=R5
	.DEF _ch_Fen=R6
	.DEF _ch_Fen_msb=R7
	.DEF _ch_Iron=R8
	.DEF _ch_Iron_msb=R9
	.DEF _Data_ch_Fen=R10
	.DEF _Data_ch_Fen_msb=R11
	.DEF _Data_ch_Iron=R12
	.DEF _Data_ch_Iron_msb=R13
	.DEF _EXT_INT0_reaction_Pause=R4

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_buf:
	.DB  0x3,0x9F,0x25,0xD,0x99,0x49,0x41,0x1F
	.DB  0x1,0x9,0xFF,0x71,0x31,0xE1,0xC1,0xEE
	.DB  0x61,0xE3,0xC7,0xF7,0x83,0x13,0xD5,0xEF
_bufY:
	.DB  0x2,0x9E,0x24,0xC,0x98,0x48,0x40,0x1E
	.DB  0x0,0x8,0x30

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x1E
_0x4:
	.DB  0x12
_0x5:
	.DB  0x13
_0x6:
	.DB  0x12
_0x7:
	.DB  0x11

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _Wite_button_time
	.DW  _0x3*2

	.DW  0x01
	.DW  _out_digit1
	.DW  _0x4*2

	.DW  0x01
	.DW  _out_digit2
	.DW  _0x5*2

	.DW  0x01
	.DW  _out_digit3
	.DW  _0x6*2

	.DW  0x01
	.DW  _out_digit4
	.DW  _0x7*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 08.12.2018
;Author  :
;Company :
;Comments:
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*******************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;#define Rele_ON PORTC |= (1 << 0)   //   //-  
;#define Rele_OFF PORTC &= ~(1 << 0) // 
;#define LED_yellow_220V_ON PORTC &= ~(1 << 1)   //  -  
;#define LED_yellow_220V_OFF PORTC |= (1 << 1) // 
;
;
;#define delay_ls 20      //  
;#define FIRST_ADC_INPUT 4
;#define LAST_ADC_INPUT 5
;unsigned int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];
;// Voltage Reference: AVCC pin
;#define ADC_VREF_TYPE ((0<<REFS1) | (1<<REFS0) | (0<<ADLAR))
;
;
;// Declare your global variables here
;    //bit EXT_INT1_Flag;
;    bit Menu_E_Flag;
;    bit Menu_U_Flag;
;    //bit Menu_U_Flag;
;    //bit svitch_ADC_Flag;
;    char OK_Flag;
;    bit EXT_INT1_reaction_Flag;
;    bit without_sound_Flag;
;    bit STOP_FEN_Flag;
;    bit STOP_Avarija_Flag;
;    int ch_1[]; //   ADC
;
;    int ch_Fen; //   ADC 
;    int ch_Iron; //   ADC 
;
;    int Data_ch_Fen; //    
;    int Data_ch_Iron; //    
;
;    char EXT_INT0_reaction_Pause;
;    char INT0_Flag;
;    char INT0_mSek;
;    char INT0_Sek;
;    bit Standby_Triger;
;    char Menu_Triger;
;    char Menu_Triger_UP;
;    char Menu_Triger_Down;
;    char Menu_Triger_Right;
;    char Menu_Triger_Left;
;
;
;    char Menu_F1,Menu_F2,Menu_F3,Menu_F4;
;    bit svitch_ADC=0;//=1,  -0
;    char Indycator_Flag; //   
;    char Step;
;    char button_Num; //  
;    char Wite_button_time_incr;  //  
;    char Wite_button_time=30; //   ()

	.DSEG
;
;   char out_digit1= 18;
;   char out_digit2= 19;
;   char out_digit3= 18;
;   char out_digit4= 17;
;   char  cur_dig;
;
;    flash char buf[] = {     //  
;    0b00000011, //0
;    0b10011111, //1
;    0b00100101, //2
;    0b00001101, //3
;    0b10011001, //4
;    0b01001001, //5
;    0b01000001, //6
;    0b00011111, //7
;    0b00000001, //8
;    0b00001001, //9
;    0b11111111, //blank
;    0b01110001, //F
;    0b00110001, //p
;    0b11100001, //t
;    0b11000001, //b
;    0b11101110, //_.
;    0b01100001, //e
;    0b11100011, //L
;    0b11000111, //v
;    0b11110111,  //i
;    0b10000011,  //V
;    0b00010011,  //
;    0b11010101, //n
;    0b11101111  //_
;                };
;    flash char bufY[] = {     //     
;    0b00000010, //0
;    0b10011110, //1
;    0b00100100, //2
;    0b00001100, //3
;    0b10011000, //4
;    0b01001000, //5
;    0b01000000, //6
;    0b00011110, //7
;    0b00000000, //8
;    0b00001000, //9
;    0b0110000   //E
;    //0b11010101, //n
;    //0b00010011  //
;    //0b00010010,  //
;    //0b11010100  //
;                   };
;
;  void hc164_wr(unsigned char dig, char h)  //    
; 0000 0083 {unsigned char a;

	.CSEG
_hc164_wr:
; .FSTART _hc164_wr
; 0000 0084  for(a=0; a<8; a++){            //   8    
	ST   -Y,R26
	ST   -Y,R17
;	dig -> Y+2
;	h -> Y+1
;	a -> R17
	LDI  R17,LOW(0)
_0x9:
	CPI  R17,8
	BRSH _0xA
; 0000 0085   if (h){PORTB.3 = bufY[dig] & 1<<a;}
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0xB
	LDD  R30,Y+2
	LDI  R31,0
	SUBI R30,LOW(-_bufY*2)
	SBCI R31,HIGH(-_bufY*2)
	RCALL SUBOPT_0x0
	BRNE _0xC
	CBI  0x18,3
	RJMP _0xD
_0xC:
	SBI  0x18,3
_0xD:
; 0000 0086    else {PORTB.3 = buf[dig] & 1<<a;}   //   DATA  
	RJMP _0xE
_0xB:
	LDD  R30,Y+2
	LDI  R31,0
	SUBI R30,LOW(-_buf*2)
	SBCI R31,HIGH(-_buf*2)
	RCALL SUBOPT_0x0
	BRNE _0xF
	CBI  0x18,3
	RJMP _0x10
_0xF:
	SBI  0x18,3
_0x10:
_0xE:
; 0000 0087    PORTB.4=0;         //  CLK  .0
	CBI  0x18,4
; 0000 0088    PORTB.4=1;         //  CLK  .1
	SBI  0x18,4
; 0000 0089                     }
	SUBI R17,-1
	RJMP _0x9
_0xA:
; 0000 008A  }
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
;
;// ADC interrupt service routine
;// with auto input scanning
;interrupt [ADC_INT] void adc_isr(void)
; 0000 008F {
_adc_isr:
; .FSTART _adc_isr
	ST   -Y,R24
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0090 static unsigned char input_index=0;
; 0000 0091 // Read the AD conversion result
; 0000 0092 adc_data[input_index]=ADCW;
	LDS  R30,_input_index_S0000001000
	LDI  R26,LOW(_adc_data)
	LDI  R27,HIGH(_adc_data)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	IN   R30,0x4
	IN   R31,0x4+1
	ST   X+,R30
	ST   X,R31
; 0000 0093 // Select next ADC input
; 0000 0094 if (++input_index > (LAST_ADC_INPUT-FIRST_ADC_INPUT))
	LDS  R26,_input_index_S0000001000
	SUBI R26,-LOW(1)
	STS  _input_index_S0000001000,R26
	CPI  R26,LOW(0x2)
	BRLO _0x15
; 0000 0095    input_index=0;
	LDI  R30,LOW(0)
	STS  _input_index_S0000001000,R30
; 0000 0096 ADMUX=(FIRST_ADC_INPUT | ADC_VREF_TYPE)+input_index;
_0x15:
	LDS  R30,_input_index_S0000001000
	SUBI R30,-LOW(68)
	OUT  0x7,R30
; 0000 0097 // Delay needed for the stabilization of the ADC input voltage
; 0000 0098 delay_us(10);
	__DELAY_USB 27
; 0000 0099 // Start the AD conversion
; 0000 009A ADCSRA|=(1<<ADSC);
	SBI  0x6,6
; 0000 009B }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R24,Y+
	RETI
; .FEND
;
;void numeric_convers(int ch_1)
; 0000 009E {
_numeric_convers:
; .FSTART _numeric_convers
; 0000 009F  out_digit1 = ch_1 % 10;
	ST   -Y,R27
	ST   -Y,R26
;	ch_1 -> Y+0
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	RCALL SUBOPT_0x1
; 0000 00A0  out_digit2 = (ch_1% 100) / 10;
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	RCALL SUBOPT_0x2
; 0000 00A1  out_digit3 = (ch_1% 1000) / 100;
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21
	RCALL SUBOPT_0x3
; 0000 00A2 }
	ADIW R28,2
	RET
; .FEND
;
;void No_Indycator(void)
; 0000 00A5   {
_No_Indycator:
; .FSTART _No_Indycator
; 0000 00A6    out_digit1 = 10;// 3 
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x1
; 0000 00A7    out_digit2 = 10;
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x2
; 0000 00A8    out_digit3 = 10;
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x3
; 0000 00A9   }
	RET
; .FEND
;
; void adc_convers(void)
; 0000 00AC {
_adc_convers:
; .FSTART _adc_convers
; 0000 00AD   switch (Indycator_Flag) {//    
	LDS  R30,_Indycator_Flag
	RCALL SUBOPT_0x4
; 0000 00AE     case 0 :{
	BRNE _0x19
; 0000 00AF         if (svitch_ADC)
	SBRS R2,7
	RJMP _0x1A
; 0000 00B0         { ch_1[0] = (adc_data[1])/2; //*5/1024)*10;
	__GETW1MN _adc_data,2
	RCALL SUBOPT_0x5
; 0000 00B1           ch_Fen = ch_1[0];
	__GETWRMN 6,7,0,_ch_1
; 0000 00B2           out_digit4= 11;}
	LDI  R30,LOW(11)
	RJMP _0xB7
; 0000 00B3           else  {ch_1[0] = (adc_data[0])/2; //*5/1024)*10
_0x1A:
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	RCALL SUBOPT_0x5
; 0000 00B4                  ch_Iron = ch_1[0];
	__GETWRMN 8,9,0,_ch_1
; 0000 00B5                  out_digit4= 12;}
	LDI  R30,LOW(12)
_0xB7:
	STS  _out_digit4,R30
; 0000 00B6 
; 0000 00B7       numeric_convers(ch_1[0]);
	LDS  R26,_ch_1
	LDS  R27,_ch_1+1
	RCALL _numeric_convers
; 0000 00B8           break;};
	RJMP _0x18
; 0000 00B9     case 1 :{ //- "Srandby"
_0x19:
	RCALL SUBOPT_0x6
	BRNE _0x1C
; 0000 00BA       out_digit1 = 15;
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x1
; 0000 00BB       out_digit2 = 14;
	LDI  R30,LOW(14)
	RCALL SUBOPT_0x2
; 0000 00BC       out_digit3 = 13;
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x3
; 0000 00BD       out_digit4 = 5;
	LDI  R30,LOW(5)
	STS  _out_digit4,R30
; 0000 00BE           break;};
	RJMP _0x18
; 0000 00BF     case 2 :{ //- "Menu "
_0x1C:
	RCALL SUBOPT_0x7
	BRNE _0x1D
; 0000 00C0        out_digit4 = 16; //"E"
	LDI  R30,LOW(16)
	STS  _out_digit4,R30
; 0000 00C1        if (Menu_E_Flag == 0){No_Indycator(); Menu_E_Flag=1;}
	SBRC R2,0
	RJMP _0x1E
	RCALL _No_Indycator
	SET
	BLD  R2,0
; 0000 00C2        if (svitch_ADC==1) {
_0x1E:
	SBRS R2,7
	RJMP _0x1F
; 0000 00C3         numeric_convers(Data_ch_Fen);
	MOVW R26,R10
	RCALL _numeric_convers
; 0000 00C4                           }
; 0000 00C5        if (svitch_ADC==0) {
_0x1F:
	SBRC R2,7
	RJMP _0x20
; 0000 00C6         numeric_convers(Data_ch_Iron);
	MOVW R26,R12
	RCALL _numeric_convers
; 0000 00C7                         }
; 0000 00C8           break;};
_0x20:
	RJMP _0x18
; 0000 00C9     case 3 :{ //- "Menu U"
_0x1D:
	RCALL SUBOPT_0x8
	BRNE _0x18
; 0000 00CA        Menu_F1=0; Menu_F2=0; Menu_F3=0;
	RCALL SUBOPT_0x9
; 0000 00CB        out_digit4 = 20; //"U"
	LDI  R30,LOW(20)
	STS  _out_digit4,R30
; 0000 00CC        if (Menu_U_Flag == 0){No_Indycator(); Menu_U_Flag=1;}
	SBRC R2,1
	RJMP _0x22
	RCALL _No_Indycator
	SET
	BLD  R2,1
; 0000 00CD           break;};
_0x22:
; 0000 00CE                          }
_0x18:
; 0000 00CF }
	RET
; .FEND
;
; void Port_Jet(void)
; 0000 00D2 {
_Port_Jet:
; .FSTART _Port_Jet
; 0000 00D3  PORTD|=(1<<4)|(1<<5)|(1<<6)|(1<<7);
	IN   R30,0x12
	ORI  R30,LOW(0xF0)
	OUT  0x12,R30
; 0000 00D4 }
	RET
; .FEND
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 00D8 {
_timer0_ovf_isr:
; .FSTART _timer0_ovf_isr
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 00D9 // Reinitialize Timer 0 value
; 0000 00DA TCNT0=0x83;
	LDI  R30,LOW(131)
	OUT  0x32,R30
; 0000 00DB // Place your code here
; 0000 00DC   INT0_Flag++;
	LDS  R30,_INT0_Flag
	SUBI R30,-LOW(1)
	STS  _INT0_Flag,R30
; 0000 00DD    if(INT0_Flag ==100){ //0,2  - 
	LDS  R26,_INT0_Flag
	CPI  R26,LOW(0x64)
	BRNE _0x23
; 0000 00DE    INT0_Flag =0;
	LDI  R30,LOW(0)
	STS  _INT0_Flag,R30
; 0000 00DF    INT0_mSek++;
	LDS  R30,_INT0_mSek
	SUBI R30,-LOW(1)
	STS  _INT0_mSek,R30
; 0000 00E0    if ((STOP_Avarija_Flag)&& (without_sound_Flag)){PORTB.0= ~PORTB.0;}
	SBRS R2,5
	RJMP _0x25
	SBRC R2,3
	RJMP _0x26
_0x25:
	RJMP _0x24
_0x26:
	SBIS 0x18,0
	RJMP _0x27
	CBI  0x18,0
	RJMP _0x28
_0x27:
	SBI  0x18,0
_0x28:
; 0000 00E1    if (INT0_mSek == 5){  //1  - 
_0x24:
	LDS  R26,_INT0_mSek
	CPI  R26,LOW(0x5)
	BRNE _0x29
; 0000 00E2    INT0_Sek++;
	LDS  R30,_INT0_Sek
	SUBI R30,-LOW(1)
	STS  _INT0_Sek,R30
; 0000 00E3    INT0_mSek =0;
	LDI  R30,LOW(0)
	STS  _INT0_mSek,R30
; 0000 00E4    }
; 0000 00E5                      }
_0x29:
; 0000 00E6 }
_0x23:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
; .FEND
; // Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00E9 {
_timer2_ovf_isr:
; .FSTART _timer2_ovf_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00EA // Reinitialize Timer2 value
; 0000 00EB  TCNT2=0xCF;     //40
	LDI  R30,LOW(207)
	OUT  0x24,R30
; 0000 00EC // Place your code here
; 0000 00ED   // adc_convers();
; 0000 00EE    switch (cur_dig)
	LDS  R30,_cur_dig
	RCALL SUBOPT_0x4
; 0000 00EF    {
; 0000 00F0 case 0:{Port_Jet(); hc164_wr(out_digit1,Menu_F1); PORTD.7=0; #asm("nop")
	BRNE _0x2D
	RCALL _Port_Jet
	LDS  R30,_out_digit1
	ST   -Y,R30
	LDS  R26,_Menu_F1
	RCALL _hc164_wr
	CBI  0x12,7
	nop
; 0000 00F1          if (!(PINC&0b00001000))  //    PBC3
	SBIC 0x13,3
	RJMP _0x30
; 0000 00F2          {   //SW702  - Up
; 0000 00F3          if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
	RCALL SUBOPT_0xA
	BRSH _0x31
	RCALL SUBOPT_0xB
; 0000 00F4 			else {Wite_button_time_incr=0; button_Num=2;}
	RJMP _0x32
_0x31:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(2)
	RCALL SUBOPT_0xD
_0x32:
; 0000 00F5          }
; 0000 00F6          break;};  // 
_0x30:
	RJMP _0x2C
; 0000 00F7 case 1:{Port_Jet(); hc164_wr(out_digit2,Menu_F2); PORTD.6=0; #asm("nop")
_0x2D:
	RCALL SUBOPT_0x6
	BRNE _0x33
	RCALL _Port_Jet
	LDS  R30,_out_digit2
	ST   -Y,R30
	LDS  R26,_Menu_F2
	RCALL _hc164_wr
	CBI  0x12,6
	nop
; 0000 00F8         if(!(PINC&0b00000100))//    PBC2  PBC3 
	SBIC 0x13,2
	RJMP _0x36
; 0000 00F9            { //SW703 - "Menu"
; 0000 00FA            if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
	RCALL SUBOPT_0xA
	BRSH _0x37
	RCALL SUBOPT_0xB
; 0000 00FB 			else {Wite_button_time_incr=0; button_Num=3;}
	RJMP _0x38
_0x37:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(3)
	RCALL SUBOPT_0xD
_0x38:
; 0000 00FC            }
; 0000 00FD          if(!(PINC&0b00001000))//    PBC2  PBC3 
_0x36:
	SBIC 0x13,3
	RJMP _0x39
; 0000 00FE          {  //SW704 "-"
; 0000 00FF           if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
	RCALL SUBOPT_0xA
	BRSH _0x3A
	RCALL SUBOPT_0xB
; 0000 0100 			else {Wite_button_time_incr=0; button_Num=4;}
	RJMP _0x3B
_0x3A:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(4)
	RCALL SUBOPT_0xD
_0x3B:
; 0000 0101          }
; 0000 0102           break;};  // 
_0x39:
	RJMP _0x2C
; 0000 0103 case 2:{Port_Jet(); hc164_wr(out_digit3,Menu_F3); PORTD.5=0; #asm("nop")
_0x33:
	RCALL SUBOPT_0x7
	BRNE _0x3C
	RCALL _Port_Jet
	LDS  R30,_out_digit3
	ST   -Y,R30
	LDS  R26,_Menu_F3
	RCALL _hc164_wr
	CBI  0x12,5
	nop
; 0000 0104         if(!(PINC&0b00000100))//    PBC2  PBC3 
	SBIC 0x13,2
	RJMP _0x3F
; 0000 0105          {  //SW705 - "Srandby"
; 0000 0106           if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
	RCALL SUBOPT_0xA
	BRSH _0x40
	RCALL SUBOPT_0xB
; 0000 0107 			else {Wite_button_time_incr=0; button_Num=5;}
	RJMP _0x41
_0x40:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(5)
	RCALL SUBOPT_0xD
_0x41:
; 0000 0108          }
; 0000 0109           if (!(PINC&0b00001000))  //    PBC3
_0x3F:
	SBIC 0x13,3
	RJMP _0x42
; 0000 010A          {   //SW706 - "Down"
; 0000 010B          if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
	RCALL SUBOPT_0xA
	BRSH _0x43
	RCALL SUBOPT_0xB
; 0000 010C 			else {Wite_button_time_incr=0; button_Num=6;}
	RJMP _0x44
_0x43:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(6)
	RCALL SUBOPT_0xD
_0x44:
; 0000 010D          }
; 0000 010E         break;};  // 
_0x42:
	RJMP _0x2C
; 0000 010F case 3:{Port_Jet(); hc164_wr(out_digit4,Menu_F4); PORTD.4=0; #asm("nop")
_0x3C:
	RCALL SUBOPT_0x8
	BRNE _0x2C
	RCALL _Port_Jet
	LDS  R30,_out_digit4
	ST   -Y,R30
	LDS  R26,_Menu_F4
	RCALL _hc164_wr
	CBI  0x12,4
	nop
; 0000 0110         if(!(PINC&0b00000100))//    PBC2  PBC3 
	SBIC 0x13,2
	RJMP _0x48
; 0000 0111          { //SW707 "OK"
; 0000 0112          if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
	RCALL SUBOPT_0xA
	BRSH _0x49
	RCALL SUBOPT_0xB
; 0000 0113 			else {Wite_button_time_incr=0; button_Num=7;}
	RJMP _0x4A
_0x49:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(7)
	RCALL SUBOPT_0xD
_0x4A:
; 0000 0114          }
; 0000 0115          if(!(PINC&0b00001000))//    PBC2  PBC3 
_0x48:
	SBIC 0x13,3
	RJMP _0x4B
; 0000 0116         {   //SW708 "+"
; 0000 0117         if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
	RCALL SUBOPT_0xA
	BRSH _0x4C
	RCALL SUBOPT_0xB
; 0000 0118 			else {Wite_button_time_incr=0; button_Num=8;}
	RJMP _0x4D
_0x4C:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(8)
	RCALL SUBOPT_0xD
_0x4D:
; 0000 0119         }
; 0000 011A         break;};  // 
_0x4B:
; 0000 011B   }
_0x2C:
; 0000 011C     cur_dig++;
	LDS  R30,_cur_dig
	SUBI R30,-LOW(1)
	STS  _cur_dig,R30
; 0000 011D     if (cur_dig==4) {cur_dig=0;}
	LDS  R26,_cur_dig
	CPI  R26,LOW(0x4)
	BRNE _0x4E
	LDI  R30,LOW(0)
	STS  _cur_dig,R30
; 0000 011E     delay_us(800); //     
_0x4E:
	__DELAY_USW 1600
; 0000 011F     PORTD.7=1;    //     
	SBI  0x12,7
; 0000 0120     PORTD.6=1;
	SBI  0x12,6
; 0000 0121     PORTD.5=1;
	SBI  0x12,5
; 0000 0122     PORTD.4=1;
	SBI  0x12,4
; 0000 0123 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;
; void increment_Temperature(void)
; 0000 0126   {
_increment_Temperature:
; .FSTART _increment_Temperature
; 0000 0127      if (svitch_ADC==1) {
	SBRS R2,7
	RJMP _0x57
; 0000 0128         Data_ch_Fen= Data_ch_Fen+Step;
	LDS  R30,_Step
	LDI  R31,0
	__ADDWRR 10,11,30,31
; 0000 0129                      }
; 0000 012A      if (svitch_ADC==0) {
_0x57:
	SBRC R2,7
	RJMP _0x58
; 0000 012B         Data_ch_Iron=Data_ch_Iron+Step;
	LDS  R30,_Step
	LDI  R31,0
	__ADDWRR 12,13,30,31
; 0000 012C                      }
; 0000 012D    }
_0x58:
	RET
; .FEND
;
;  void STOP_FEN(void)
; 0000 0130   {  if (STOP_FEN_Flag){
_STOP_FEN:
; .FSTART _STOP_FEN
	SBRS R2,4
	RJMP _0x59
; 0000 0131      if(INT0_Sek ==0) {OCR1BL=0xFF;out_digit1 =7;}
	LDS  R30,_INT0_Sek
	CPI  R30,0
	BRNE _0x5A
	LDI  R30,LOW(255)
	OUT  0x28,R30
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x1
; 0000 0132      if(INT0_Sek ==1) {OCR1BL=0xDF;out_digit1 =6;}
_0x5A:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x1)
	BRNE _0x5B
	LDI  R30,LOW(223)
	OUT  0x28,R30
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x1
; 0000 0133      if(INT0_Sek ==2) {OCR1BL=0xCF;out_digit1 =5;}
_0x5B:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x2)
	BRNE _0x5C
	LDI  R30,LOW(207)
	OUT  0x28,R30
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x1
; 0000 0134      if(INT0_Sek ==3) {OCR1BL=0xBF;out_digit1 =4;}
_0x5C:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x3)
	BRNE _0x5D
	LDI  R30,LOW(191)
	OUT  0x28,R30
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1
; 0000 0135      if(INT0_Sek ==4) {OCR1BL=0xAF;out_digit1 =3;}
_0x5D:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x4)
	BRNE _0x5E
	LDI  R30,LOW(175)
	OUT  0x28,R30
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x1
; 0000 0136      if(INT0_Sek ==5) {OCR1BL=0x5F;out_digit1 =2;}
_0x5E:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x5)
	BRNE _0x5F
	LDI  R30,LOW(95)
	OUT  0x28,R30
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x1
; 0000 0137      if(INT0_Sek ==6) {OCR1BL=0x1F;out_digit1 =1;}
_0x5F:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x6)
	BRNE _0x60
	LDI  R30,LOW(31)
	OUT  0x28,R30
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1
; 0000 0138      if(INT0_Sek ==7) {OCR1BL=0x00;out_digit1 =0;
_0x60:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x7)
	BRNE _0x61
	LDI  R30,LOW(0)
	OUT  0x28,R30
	RCALL SUBOPT_0x1
; 0000 0139                        INT0_Sek = 0;
	LDI  R30,LOW(0)
	STS  _INT0_Sek,R30
; 0000 013A                        STOP_FEN_Flag=0;}}
	CLT
	BLD  R2,4
_0x61:
; 0000 013B 
; 0000 013C   }
_0x59:
	RET
; .FEND
;
;  void decrement_Temperature(void)
; 0000 013F   {
_decrement_Temperature:
; .FSTART _decrement_Temperature
; 0000 0140    if ((svitch_ADC==1)&&(Data_ch_Fen >=Step))
	SBRS R2,7
	RJMP _0x63
	LDS  R30,_Step
	MOVW R26,R10
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x64
_0x63:
	RJMP _0x62
_0x64:
; 0000 0141                      {Data_ch_Fen= Data_ch_Fen-Step;}
	LDS  R26,_Step
	CLR  R27
	__SUBWRR 10,11,26,27
; 0000 0142            else {Data_ch_Fen=0;}
	RJMP _0x65
_0x62:
	CLR  R10
	CLR  R11
_0x65:
; 0000 0143      if ((svitch_ADC==0)&&(Data_ch_Iron >=Step))
	SBRC R2,7
	RJMP _0x67
	LDS  R30,_Step
	MOVW R26,R12
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x68
_0x67:
	RJMP _0x66
_0x68:
; 0000 0144                      {Data_ch_Iron= Data_ch_Iron-Step;}
	LDS  R26,_Step
	CLR  R27
	__SUBWRR 12,13,26,27
; 0000 0145   }
_0x66:
	RET
; .FEND
;
;
;
; void converts_Button (void)
; 0000 014A {
_converts_Button:
; .FSTART _converts_Button
; 0000 014B  if (button_Num==3)  //SW703 - "Menu"
	RCALL SUBOPT_0xF
	CPI  R26,LOW(0x3)
	BRNE _0x69
; 0000 014C   {
; 0000 014D    switch (Menu_Triger) {//  =1   -0
	LDS  R30,_Menu_Triger
	RCALL SUBOPT_0x4
; 0000 014E     case 0:{
	BRNE _0x6D
; 0000 014F              Menu_Triger=1;    //
	LDI  R30,LOW(1)
	STS  _Menu_Triger,R30
; 0000 0150              svitch_ADC = 1; //   Fen
	SET
	BLD  R2,7
; 0000 0151              without_sound_Flag=1;
	BLD  R2,3
; 0000 0152              Rele_ON; // 
	SBI  0x15,0
; 0000 0153              Menu_U_Flag = 0;
	CLT
	BLD  R2,1
; 0000 0154              STOP_FEN_Flag=0;
	BLD  R2,4
; 0000 0155              OCR1AL=0x00;  //  
	LDI  R30,LOW(0)
	OUT  0x2A,R30
; 0000 0156              break;};
	RJMP _0x6C
; 0000 0157     case 1:{
_0x6D:
	RCALL SUBOPT_0x6
	BRNE _0x6C
; 0000 0158              Menu_Triger=0;    //
	LDI  R30,LOW(0)
	STS  _Menu_Triger,R30
; 0000 0159              svitch_ADC = 0; //   Pajalnyk
	CLT
	BLD  R2,7
; 0000 015A              Rele_OFF; // 
	CBI  0x15,0
; 0000 015B              without_sound_Flag=0;
	BLD  R2,3
; 0000 015C              INT0_Sek = 0;
	STS  _INT0_Sek,R30
; 0000 015D              if (ch_Fen>=50){STOP_FEN_Flag=1;}
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R6,R30
	CPC  R7,R31
	BRLT _0x6F
	SET
	BLD  R2,4
; 0000 015E              break;};
_0x6F:
; 0000 015F                       }
_0x6C:
; 0000 0160   }
; 0000 0161   if (button_Num==5)
_0x69:
	RCALL SUBOPT_0xF
	CPI  R26,LOW(0x5)
	BRNE _0x70
; 0000 0162   {                        //SW705 - "Standby"
; 0000 0163        if (Standby_Triger==0){
	SBRC R2,6
	RJMP _0x71
; 0000 0164          Rele_OFF; // 
	CBI  0x15,0
; 0000 0165          LED_yellow_220V_OFF;//    220 
	SBI  0x15,1
; 0000 0166          Indycator_Flag =1;// - "Srandby"
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x10
; 0000 0167          Standby_Triger=1; //  
	SET
	BLD  R2,6
; 0000 0168          OCR1AL=0x00;  //  
	LDI  R30,LOW(0)
	OUT  0x2A,R30
; 0000 0169          STOP_FEN_Flag=1;// 
	BLD  R2,4
; 0000 016A          Data_ch_Fen=0;
	CLR  R10
	CLR  R11
; 0000 016B          Data_ch_Iron=0;
	CLR  R12
	CLR  R13
; 0000 016C          STOP_Avarija_Flag=0;//   -   
	CLT
	BLD  R2,5
; 0000 016D                              }
; 0000 016E          else {
	RJMP _0x72
_0x71:
; 0000 016F          Indycator_Flag =0;// - "Srandby" - 
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x10
; 0000 0170          Standby_Triger=0;
	CLT
	BLD  R2,6
; 0000 0171          without_sound_Flag=0;
	BLD  R2,3
; 0000 0172                     }
_0x72:
; 0000 0173   }
; 0000 0174   if (button_Num==7)    //SW707 "OK"
_0x70:
	RCALL SUBOPT_0xF
	CPI  R26,LOW(0x7)
	BRNE _0x73
; 0000 0175   {   if (svitch_ADC==0) {
	SBRC R2,7
	RJMP _0x74
; 0000 0176         switch (OK_Flag) {
	MOV  R30,R5
	RCALL SUBOPT_0x4
; 0000 0177          case 0 :{Indycator_Flag=2;
	BRNE _0x78
	RCALL SUBOPT_0x11
; 0000 0178                 OK_Flag=1;
; 0000 0179                 break;};
	RJMP _0x77
; 0000 017A          case 1 :{Indycator_Flag=0;// -   Menu
_0x78:
	RCALL SUBOPT_0x6
	BRNE _0x77
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x10
; 0000 017B                   OK_Flag=0;
	CLR  R5
; 0000 017C                   Menu_F1=0; Menu_F2=0; Menu_F3=0;
	RCALL SUBOPT_0x9
; 0000 017D                   OCR1AL=0xCF;//  
	LDI  R30,LOW(207)
	OUT  0x2A,R30
; 0000 017E                   Menu_U_Flag = 0;
	CLT
	BLD  R2,1
; 0000 017F                   Menu_E_Flag = 0;
	BLD  R2,0
; 0000 0180                 break;};
; 0000 0181                         }
_0x77:
; 0000 0182                         }
; 0000 0183      else{
	RJMP _0x7A
_0x74:
; 0000 0184 
; 0000 0185       switch (OK_Flag) {//    
	MOV  R30,R5
	RCALL SUBOPT_0x4
; 0000 0186        case 0 :{Indycator_Flag=2;
	BRNE _0x7E
	RCALL SUBOPT_0x11
; 0000 0187                 OK_Flag=1;
; 0000 0188                 break;};
	RJMP _0x7D
; 0000 0189        case 1 :{Indycator_Flag=3;// -   Menu
_0x7E:
	RCALL SUBOPT_0x6
	BRNE _0x7F
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x10
; 0000 018A                 OK_Flag=2;
	LDI  R30,LOW(2)
	MOV  R5,R30
; 0000 018B                 without_sound_Flag=1;// 
	SET
	BLD  R2,3
; 0000 018C                 break;};
	RJMP _0x7D
; 0000 018D        case 2 :{Indycator_Flag=0;// -   Menu
_0x7F:
	RCALL SUBOPT_0x7
	BRNE _0x7D
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x10
; 0000 018E                 OK_Flag=0;
	CLR  R5
; 0000 018F                 Menu_Triger_UP=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x12
; 0000 0190                 Menu_Triger_Down=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x13
; 0000 0191                 //Menu_U_Flag=0;
; 0000 0192                 Rele_ON;
	SBI  0x15,0
; 0000 0193                 break;};
; 0000 0194                 }
_0x7D:
; 0000 0195           }
_0x7A:
; 0000 0196  }
; 0000 0197 
; 0000 0198    if (button_Num==2) //SW702 - "Up"
_0x73:
	RCALL SUBOPT_0xF
	CPI  R26,LOW(0x2)
	BRNE _0x81
; 0000 0199   {
; 0000 019A      switch (Menu_Triger_UP){
	LDS  R30,_Menu_Triger_UP
	RCALL SUBOPT_0x4
; 0000 019B         case 0:{increment_Temperature();
	BRNE _0x85
	RCALL _increment_Temperature
; 0000 019C                 if (Indycator_Flag==3) {Menu_Triger_UP=1;}
	LDS  R26,_Indycator_Flag
	CPI  R26,LOW(0x3)
	BRNE _0x86
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x12
; 0000 019D                 break;};
_0x86:
	RJMP _0x84
; 0000 019E         case 1:{out_digit3 = 23;
_0x85:
	RCALL SUBOPT_0x6
	BRNE _0x87
	RCALL SUBOPT_0x14
; 0000 019F                 out_digit2 = 23;
; 0000 01A0                 out_digit1 = 23;
; 0000 01A1                 OCR1BL=0x5F;
; 0000 01A2                 Menu_Triger_Down=Menu_Triger_UP;
	LDS  R30,_Menu_Triger_UP
	RCALL SUBOPT_0x13
; 0000 01A3                 Menu_Triger_UP=2;
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x12
; 0000 01A4                 break;};
	RJMP _0x84
; 0000 01A5         case 2:{out_digit3 = 22;
_0x87:
	RCALL SUBOPT_0x7
	BRNE _0x88
	RCALL SUBOPT_0x15
; 0000 01A6                 out_digit2 = 22;
; 0000 01A7                 out_digit1 = 22;
; 0000 01A8                 OCR1BL=0xBF;
; 0000 01A9                 Menu_Triger_Down=Menu_Triger_UP;
	LDS  R30,_Menu_Triger_UP
	RCALL SUBOPT_0x13
; 0000 01AA                 Menu_Triger_UP=3;
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x12
; 0000 01AB                 break;};
	RJMP _0x84
; 0000 01AC         case 3:{out_digit3 = 21;
_0x88:
	RCALL SUBOPT_0x8
	BRNE _0x84
	RCALL SUBOPT_0x16
; 0000 01AD                 out_digit2 = 21;
; 0000 01AE                 out_digit1 = 21;
; 0000 01AF                 OCR1BL=0xFF;
; 0000 01B0                 Menu_Triger_Down=1;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x13
; 0000 01B1                 //Menu_Triger_UP=1;
; 0000 01B2                 break;};
; 0000 01B3 
; 0000 01B4   }                       }
_0x84:
; 0000 01B5 
; 0000 01B6    if (button_Num==6) //  =1   -0
_0x81:
	RCALL SUBOPT_0xF
	CPI  R26,LOW(0x6)
	BRNE _0x8A
; 0000 01B7   {              //SW706 - "Down"
; 0000 01B8    switch (Menu_Triger_Down){
	LDS  R30,_Menu_Triger_Down
	RCALL SUBOPT_0x4
; 0000 01B9         case 0:{decrement_Temperature();
	BRNE _0x8E
	RCALL _decrement_Temperature
; 0000 01BA                 if (Indycator_Flag==3) {Menu_Triger_Down=1;}
	RCALL SUBOPT_0x17
	CPI  R26,LOW(0x3)
	BRNE _0x8F
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x13
; 0000 01BB                 break;};
_0x8F:
	RJMP _0x8D
; 0000 01BC         case 1:{out_digit3 = 21;
_0x8E:
	RCALL SUBOPT_0x6
	BRNE _0x90
	RCALL SUBOPT_0x16
; 0000 01BD                 out_digit2 = 21;
; 0000 01BE                 out_digit1 = 21;
; 0000 01BF                 OCR1BL=0xFF;
; 0000 01C0                 Menu_Triger_UP=Menu_Triger_Down;
	LDS  R30,_Menu_Triger_Down
	RCALL SUBOPT_0x12
; 0000 01C1                 Menu_Triger_Down=2;
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x13
; 0000 01C2                 break;};
	RJMP _0x8D
; 0000 01C3         case 2:{out_digit3 = 22;
_0x90:
	RCALL SUBOPT_0x7
	BRNE _0x91
	RCALL SUBOPT_0x15
; 0000 01C4                 out_digit2 = 22;
; 0000 01C5                 out_digit1 = 22;
; 0000 01C6                 OCR1BL=0xBF;
; 0000 01C7                 Menu_Triger_UP=Menu_Triger_Down;
	LDS  R30,_Menu_Triger_Down
	RCALL SUBOPT_0x12
; 0000 01C8                 Menu_Triger_Down=3;
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x13
; 0000 01C9                 break;};
	RJMP _0x8D
; 0000 01CA         case 3:{out_digit3 = 23;
_0x91:
	RCALL SUBOPT_0x8
	BRNE _0x8D
	RCALL SUBOPT_0x14
; 0000 01CB                 out_digit2 = 23;
; 0000 01CC                 out_digit1 = 23;
; 0000 01CD                 OCR1BL=0x5F;
; 0000 01CE                 Menu_Triger_UP=1;
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x12
; 0000 01CF                 //Menu_Triger_Down=1;
; 0000 01D0                 break;}; }
_0x8D:
; 0000 01D1   }
; 0000 01D2 
; 0000 01D3      if (button_Num==4)   //SW704 "Left"
_0x8A:
	RCALL SUBOPT_0xF
	CPI  R26,LOW(0x4)
	BRNE _0x93
; 0000 01D4   {
; 0000 01D5     if (Indycator_Flag==2){
	RCALL SUBOPT_0x17
	CPI  R26,LOW(0x2)
	BRNE _0x94
; 0000 01D6        switch (Menu_Triger_Left){
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x4
; 0000 01D7         case 0:{
	BRNE _0x98
; 0000 01D8                 Menu_F3=0;
	RCALL SUBOPT_0x19
; 0000 01D9                 Menu_F1=1;
	RCALL SUBOPT_0x1A
; 0000 01DA                 Menu_Triger_Left = 1;
	RCALL SUBOPT_0x1B
; 0000 01DB                 Menu_Triger_Right= Menu_Triger_Left;
; 0000 01DC                 Step =1;
	LDI  R30,LOW(1)
	RJMP _0xB8
; 0000 01DD                 break;};
; 0000 01DE         case 1:{
_0x98:
	RCALL SUBOPT_0x6
	BRNE _0x99
; 0000 01DF                 Menu_F1=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1A
; 0000 01E0                 Menu_F2=1;
	RCALL SUBOPT_0x1C
; 0000 01E1                 Menu_Triger_Left = 2;
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x1B
; 0000 01E2                 Menu_Triger_Right= Menu_Triger_Left;
; 0000 01E3                  Step =10;
	LDI  R30,LOW(10)
	RJMP _0xB8
; 0000 01E4                 break;};
; 0000 01E5         case 2:{
_0x99:
	RCALL SUBOPT_0x7
	BRNE _0x97
; 0000 01E6                 Menu_F2=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1C
; 0000 01E7                 Menu_F3=1;
	LDI  R30,LOW(1)
	STS  _Menu_F3,R30
; 0000 01E8                 Menu_Triger_Left = 0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1B
; 0000 01E9                 Menu_Triger_Right= Menu_Triger_Left;
; 0000 01EA                 Step =100;
	LDI  R30,LOW(100)
_0xB8:
	STS  _Step,R30
; 0000 01EB                 break;};
; 0000 01EC          }
_0x97:
; 0000 01ED                        }
; 0000 01EE  button_Num=0;
_0x94:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xD
; 0000 01EF   }
; 0000 01F0 
; 0000 01F1   if (button_Num==8)    //SW708 "Right"
_0x93:
	RCALL SUBOPT_0xF
	CPI  R26,LOW(0x8)
	BRNE _0x9B
; 0000 01F2   {
; 0000 01F3    if (Indycator_Flag==2){
	RCALL SUBOPT_0x17
	CPI  R26,LOW(0x2)
	BRNE _0x9C
; 0000 01F4      switch (Menu_Triger_Right){
	LDS  R30,_Menu_Triger_Right
	RCALL SUBOPT_0x4
; 0000 01F5         case 0:{Step =100;
	BRNE _0xA0
	LDI  R30,LOW(100)
	STS  _Step,R30
; 0000 01F6                 Menu_F1=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1A
; 0000 01F7                 Menu_F3=1;
	STS  _Menu_F3,R30
; 0000 01F8                 Menu_Triger_Right = 1;
	LDI  R30,LOW(1)
	RJMP _0xB9
; 0000 01F9                 Menu_Triger_Left = Menu_Triger_Right;
; 0000 01FA                 break;};
; 0000 01FB         case 1:{Step =10;
_0xA0:
	RCALL SUBOPT_0x6
	BRNE _0xA1
	LDI  R30,LOW(10)
	STS  _Step,R30
; 0000 01FC                 Menu_F3=0;
	RCALL SUBOPT_0x19
; 0000 01FD                 Menu_F2=1;
	RCALL SUBOPT_0x1C
; 0000 01FE                 Menu_Triger_Right = 2;
	LDI  R30,LOW(2)
	RJMP _0xB9
; 0000 01FF                 Menu_Triger_Left = Menu_Triger_Right;
; 0000 0200                 break;};
; 0000 0201         case 2:{Step =1;
_0xA1:
	RCALL SUBOPT_0x7
	BRNE _0x9F
	LDI  R30,LOW(1)
	STS  _Step,R30
; 0000 0202                 Menu_F2=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1C
; 0000 0203                 Menu_F1=1;
	LDI  R30,LOW(1)
	STS  _Menu_F1,R30
; 0000 0204                 Menu_Triger_Right = 0;
	LDI  R30,LOW(0)
_0xB9:
	STS  _Menu_Triger_Right,R30
; 0000 0205                 Menu_Triger_Left = Menu_Triger_Right;
	STS  _Menu_Triger_Left,R30
; 0000 0206                 break;};
; 0000 0207                 }
_0x9F:
; 0000 0208      }
; 0000 0209     }
_0x9C:
; 0000 020A   button_Num=0;
_0x9B:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xD
; 0000 020B }
	RET
; .FEND
;
;
;
; void Analize_controll_temperature (void)
; 0000 0210  {
_Analize_controll_temperature:
; .FSTART _Analize_controll_temperature
; 0000 0211      if ((svitch_ADC)&&(Indycator_Flag==0)&&(ch_Fen < Data_ch_Fen)&&(EXT_INT1_reaction_Flag==0))
	SBRS R2,7
	RJMP _0xA4
	RCALL SUBOPT_0x17
	CPI  R26,LOW(0x0)
	BRNE _0xA4
	__CPWRR 6,7,10,11
	BRGE _0xA4
	SBRS R2,2
	RJMP _0xA5
_0xA4:
	RJMP _0xA3
_0xA5:
; 0000 0212          {LED_yellow_220V_ON;  //   
	CBI  0x15,1
; 0000 0213          }
; 0000 0214            else  {LED_yellow_220V_OFF;}  //    220 
	RJMP _0xA6
_0xA3:
	SBI  0x15,1
_0xA6:
; 0000 0215           if (ch_Fen > 400) {LED_yellow_220V_OFF;  //    220 
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	CP   R30,R6
	CPC  R31,R7
	BRGE _0xA7
	SBI  0x15,1
; 0000 0216                              STOP_FEN_Flag=1;}// 
	SET
	BLD  R2,4
; 0000 0217 
; 0000 0218      if ((svitch_ADC==0)&&(Indycator_Flag==0)&&(ch_Iron < Data_ch_Iron))
_0xA7:
	SBRC R2,7
	RJMP _0xA9
	RCALL SUBOPT_0x17
	CPI  R26,LOW(0x0)
	BRNE _0xA9
	__CPWRR 8,9,12,13
	BRLT _0xAA
_0xA9:
	RJMP _0xA8
_0xAA:
; 0000 0219             {OCR1AL=0xDF;}// 
	LDI  R30,LOW(223)
	RJMP _0xBA
; 0000 021A       else  {OCR1AL=0x00;}// 
_0xA8:
	LDI  R30,LOW(0)
_0xBA:
	OUT  0x2A,R30
; 0000 021B  }
	RET
; .FEND
;
;  void EXT_INT0_reaction (void) //   
; 0000 021E  { if (PIND & (1<<PIND2)){ //   D2-1  -   
_EXT_INT0_reaction:
; .FSTART _EXT_INT0_reaction
	SBIS 0x10,2
	RJMP _0xAC
; 0000 021F 
; 0000 0220      if ((PIND & (1<<PIND2))&& (INT0_Sek > EXT_INT0_reaction_Pause)&&(Indycator_Flag ==0)) {////   ...
	SBIS 0x10,2
	RJMP _0xAE
	RCALL SUBOPT_0xE
	CP   R4,R26
	BRSH _0xAE
	RCALL SUBOPT_0x17
	CPI  R26,LOW(0x0)
	BREQ _0xAF
_0xAE:
	RJMP _0xAD
_0xAF:
; 0000 0221      Rele_OFF; // 
	CBI  0x15,0
; 0000 0222        STOP_Avarija_Flag=1;//  
	SET
	BLD  R2,5
; 0000 0223        }
; 0000 0224       EXT_INT0_reaction_Pause = INT0_Sek;
_0xAD:
	LDS  R4,_INT0_Sek
; 0000 0225        }
; 0000 0226      else {STOP_Avarija_Flag=0;}
	RJMP _0xB0
_0xAC:
	CLT
	BLD  R2,5
_0xB0:
; 0000 0227  }
	RET
; .FEND
;
;void EXT_INT1_reaction (void)  //   
; 0000 022A  { if(!(PIND&0b00001000)) {EXT_INT1_reaction_Flag=1;}
_EXT_INT1_reaction:
; .FSTART _EXT_INT1_reaction
	SBIC 0x10,3
	RJMP _0xB1
	SET
	RJMP _0xBB
; 0000 022B      else {EXT_INT1_reaction_Flag=0;}
_0xB1:
	CLT
_0xBB:
	BLD  R2,2
; 0000 022C  }
	RET
; .FEND
;
;void main(void)
; 0000 022F {
_main:
; .FSTART _main
; 0000 0230 // Declare your local variables here
; 0000 0231 
; 0000 0232 // Input/Output Ports initialization
; 0000 0233 // Port B initialization
; 0000 0234 // Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out
; 0000 0235 DDRB=(1<<DDB7) | (1<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 0236 // State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0
; 0000 0237 PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0238 
; 0000 0239 // Port C initialization
; 0000 023A // Function: Bit6=Out Bit5=In Bit4=In Bit3=In Bit2=In Bit1=Out Bit0=Out
; 0000 023B DDRC=(1<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (1<<DDC1) | (1<<DDC0);
	LDI  R30,LOW(67)
	OUT  0x14,R30
; 0000 023C // State: Bit6=0 Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T
; 0000 023D PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 023E 
; 0000 023F // Port D initialization
; 0000 0240 // Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=In Bit2=In Bit1=Out Bit0=Out
; 0000 0241 DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (0<<DDD3) | (0<<DDD2) | (1<<DDD1) | (1<<DDD0);
	LDI  R30,LOW(243)
	OUT  0x11,R30
; 0000 0242 // State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=T Bit2=T Bit1=0 Bit0=0
; 0000 0243 PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0244 
; 0000 0245 // Timer/Counter 0 initialization
; 0000 0246 // Clock source: System Clock
; 0000 0247 // Clock value: 125,000 kHz
; 0000 0248 TCCR0=(0<<CS02) | (1<<CS01) | (1<<CS00);
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 0249 TCNT0=0x83;
	LDI  R30,LOW(131)
	OUT  0x32,R30
; 0000 024A 
; 0000 024B // Timer/Counter 1 initialization
; 0000 024C // Clock source: System Clock
; 0000 024D // Clock value: 7,813 kHz
; 0000 024E // Mode: Ph. correct PWM top=OCR1A
; 0000 024F // OC1A output: Non-Inverted PWM
; 0000 0250 // OC1B output: Non-Inverted PWM
; 0000 0251 // Noise Canceler: Off
; 0000 0252 // Input Capture on Falling Edge
; 0000 0253 // Timer Period: 0 us
; 0000 0254 // Output Pulse(s):
; 0000 0255 // OC1A Period: 0 us// OC1B Period: 0 us
; 0000 0256 // Timer1 Overflow Interrupt: Off
; 0000 0257 // Input Capture Interrupt: Off
; 0000 0258 // Compare A Match Interrupt: Off
; 0000 0259 // Compare B Match Interrupt: Off
; 0000 025A 
; 0000 025B TCCR1A=0b10100001;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
; 0000 025C TCCR1B=0b00000011;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
; 0000 025D TCNT1 = 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
; 0000 025E TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 025F TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0260 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0261 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0262 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0263 OCR1AL=0x50;//OCR1AL=0x64;  // 
	LDI  R30,LOW(80)
	OUT  0x2A,R30
; 0000 0264 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 0265 OCR1BL=0xF0;//OCR1BL=0x64;
	LDI  R30,LOW(240)
	OUT  0x28,R30
; 0000 0266 
; 0000 0267 // Timer/Counter 2 initialization
; 0000 0268 // Clock source: System Clock
; 0000 0269 // Clock value: 7,813 kHz
; 0000 026A // Mode: Normal top=0xFF
; 0000 026B // OC2 output: Disconnected
; 0000 026C // Timer Period: 9,984 ms
; 0000 026D ASSR=0<<AS2;
	LDI  R30,LOW(0)
	OUT  0x22,R30
; 0000 026E TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (1<<CS22) | (1<<CS21) | (1<<CS20);
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 026F TCNT2=0xB2;
	LDI  R30,LOW(178)
	OUT  0x24,R30
; 0000 0270 OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 0271    /*
; 0000 0272 // External Interrupt(s) initialization
; 0000 0273 // INT0: On
; 0000 0274 // INT0 Mode: Low level
; 0000 0275 // INT1: On
; 0000 0276 // INT1 Mode: Low level
; 0000 0277 GICR|=(1<<INT1) | (1<<INT0);
; 0000 0278 MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
; 0000 0279 GIFR=(1<<INTF1) | (1<<INTF0);
; 0000 027A    */
; 0000 027B  // External Interrupt(s) initialization
; 0000 027C // INT0: Off
; 0000 027D // INT1: Off
; 0000 027E MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
	OUT  0x35,R30
; 0000 027F 
; 0000 0280 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0281 TIMSK=(0<<OCIE2) | (1<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 0282 
; 0000 0283 // Analog Comparator initialization
; 0000 0284 // Analog Comparator: Off
; 0000 0285 // The Analog Comparator's positive input is
; 0000 0286 // connected to the AIN0 pin
; 0000 0287 // The Analog Comparator's negative input is
; 0000 0288 // connected to the AIN1 pin
; 0000 0289 ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 028A 
; 0000 028B // ADC initialization
; 0000 028C // ADC Clock frequency: 125,000 kHz
; 0000 028D // ADC Voltage Reference: AVCC pin
; 0000 028E ADMUX=FIRST_ADC_INPUT | ADC_VREF_TYPE;
	LDI  R30,LOW(68)
	OUT  0x7,R30
; 0000 028F ADCSRA=(1<<ADEN) | (1<<ADSC) | (0<<ADFR) | (0<<ADIF) | (1<<ADIE) | (1<<ADPS2) | (1<<ADPS1) | (0<<ADPS0);
	LDI  R30,LOW(206)
	OUT  0x6,R30
; 0000 0290 SFIOR=(0<<ACME);
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0291 
; 0000 0292 
; 0000 0293 // Global enable interrupts
; 0000 0294 #asm("sei")
	sei
; 0000 0295 delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
; 0000 0296 button_Num=5;// 
	LDI  R30,LOW(5)
	RCALL SUBOPT_0xD
; 0000 0297 
; 0000 0298 while (1)
_0xB3:
; 0000 0299       {
; 0000 029A       // Place your code here
; 0000 029B           converts_Button();
	RCALL _converts_Button
; 0000 029C           adc_convers();
	RCALL _adc_convers
; 0000 029D           Analize_controll_temperature();
	RCALL _Analize_controll_temperature
; 0000 029E           EXT_INT0_reaction();
	RCALL _EXT_INT0_reaction
; 0000 029F           EXT_INT1_reaction();
	RCALL _EXT_INT1_reaction
; 0000 02A0           STOP_FEN();
	RCALL _STOP_FEN
; 0000 02A1 
; 0000 02A2 
; 0000 02A3       }
	RJMP _0xB3
; 0000 02A4 }
_0xB6:
	RJMP _0xB6
; .FEND

	.DSEG
_adc_data:
	.BYTE 0x4
_ch_1:
	.BYTE 0x2
_INT0_Flag:
	.BYTE 0x1
_INT0_mSek:
	.BYTE 0x1
_INT0_Sek:
	.BYTE 0x1
_Menu_Triger:
	.BYTE 0x1
_Menu_Triger_UP:
	.BYTE 0x1
_Menu_Triger_Down:
	.BYTE 0x1
_Menu_Triger_Right:
	.BYTE 0x1
_Menu_Triger_Left:
	.BYTE 0x1
_Menu_F1:
	.BYTE 0x1
_Menu_F2:
	.BYTE 0x1
_Menu_F3:
	.BYTE 0x1
_Menu_F4:
	.BYTE 0x1
_Indycator_Flag:
	.BYTE 0x1
_Step:
	.BYTE 0x1
_button_Num:
	.BYTE 0x1
_Wite_button_time_incr:
	.BYTE 0x1
_Wite_button_time:
	.BYTE 0x1
_out_digit1:
	.BYTE 0x1
_out_digit2:
	.BYTE 0x1
_out_digit3:
	.BYTE 0x1
_out_digit4:
	.BYTE 0x1
_cur_dig:
	.BYTE 0x1
_input_index_S0000001000:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	LPM  R1,Z
	MOV  R30,R17
	LDI  R26,LOW(1)
	RCALL __LSLB12
	AND  R30,R1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x1:
	STS  _out_digit1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2:
	STS  _out_digit2,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	STS  _out_digit3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4:
	LDI  R31,0
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	LSR  R31
	ROR  R30
	STS  _ch_1,R30
	STS  _ch_1+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x6:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(0)
	STS  _Menu_F1,R30
	STS  _Menu_F2,R30
	STS  _Menu_F3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xA:
	LDS  R30,_Wite_button_time
	LDS  R26,_Wite_button_time_incr
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xB:
	LDS  R30,_Wite_button_time_incr
	SUBI R30,-LOW(1)
	STS  _Wite_button_time_incr,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(0)
	STS  _Wite_button_time_incr,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xD:
	STS  _button_Num,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	LDS  R26,_INT0_Sek
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	LDS  R26,_button_Num
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x10:
	STS  _Indycator_Flag,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x10
	LDI  R30,LOW(1)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x12:
	STS  _Menu_Triger_UP,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x13:
	STS  _Menu_Triger_Down,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(23)
	RCALL SUBOPT_0x3
	LDI  R30,LOW(23)
	RCALL SUBOPT_0x2
	LDI  R30,LOW(23)
	RCALL SUBOPT_0x1
	LDI  R30,LOW(95)
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(22)
	RCALL SUBOPT_0x3
	LDI  R30,LOW(22)
	RCALL SUBOPT_0x2
	LDI  R30,LOW(22)
	RCALL SUBOPT_0x1
	LDI  R30,LOW(191)
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(21)
	RCALL SUBOPT_0x3
	LDI  R30,LOW(21)
	RCALL SUBOPT_0x2
	LDI  R30,LOW(21)
	RCALL SUBOPT_0x1
	LDI  R30,LOW(255)
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x17:
	LDS  R26,_Indycator_Flag
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LDS  R30,_Menu_Triger_Left
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(0)
	STS  _Menu_F3,R30
	LDI  R30,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	STS  _Menu_F1,R30
	LDI  R30,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1B:
	STS  _Menu_Triger_Left,R30
	RCALL SUBOPT_0x18
	STS  _Menu_Triger_Right,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	STS  _Menu_F2,R30
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

;END OF CODE MARKER
__END_OF_CODE:
